﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FarPoint.Win.Spread;
using FarPoint.Win.Spread.Model;

namespace PrintSelectedRows
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
           fpSpread1.SelectionBlockOptions = SelectionBlockOptions.Rows;
            fpSpread1.Sheets[0].SelectionPolicy = SelectionPolicy.MultiRange;
            fpSpread1.Sheets[0].AlternatingRows.Count = 3;
            fpSpread1.Sheets[0].AlternatingRows[0].BackColor = Color.WhiteSmoke;
            fpSpread1.Sheets[0].AlternatingRows[0].ForeColor = Color.Red;
            fpSpread1.Sheets[0].AlternatingRows[1].BackColor = Color.White;
            fpSpread1.Sheets[0].AlternatingRows[1].ForeColor = Color.Black;
            fpSpread1.Sheets[0].AlternatingRows[2].BackColor = Color.White;
            fpSpread1.Sheets[0].AlternatingRows[2].ForeColor = Color.Blue;
            fpSpread1.Sheets[0].Columns[0].Label = "ABC";
         
        }

        private void button1_Click(object sender, EventArgs e)
        {

            if (fpSpread1.ActiveSheet.SelectionCount > 0)
            {
                SheetView sv;
                //Copy original SheetView to a temporary created SheetView
                sv = (FarPoint.Win.Spread.SheetView)FarPoint.Win.Serializer.LoadObjectXml(typeof(FarPoint.Win.Spread.SheetView), FarPoint.Win.Serializer.GetObjectXml(fpSpread1.ActiveSheet, "CopySheet"), "CopySheet");
                sv.SheetName = "CopySheet";


                for (int _rowIndex = fpSpread1.ActiveSheet.RowCount - 1; _rowIndex >= 0; _rowIndex--)
                {
                    if (!fpSpread1.ActiveSheet.IsAnyCellInRowSelected(_rowIndex))
                    {
                        sv.Rows[_rowIndex].Visible = false; //Set Visible 'False' when row is not selected
                    }
                }
                //...........................
                #region RowNumbering
                //
                //Write the following code if you want Selected rows with sequence numbering
                //
                int count = 1;
                for (int _rowIndex = 0; _rowIndex < sv.RowCount; _rowIndex++)
                {
                    if (sv.Rows[_rowIndex].Visible)
                    {
                        sv.Rows[_rowIndex].Label = count.ToString();
                        count++;
                    }
                }
                //.............................
                #endregion

                //Print new created sheet
                sv.PrintInfo.Centering = Centering.Horizontal;
                sv.PrintInfo.Preview = true;
                fpSpread1.PrintSheet(sv);
            }
            else
                MessageBox.Show("There is no row selected. Please select the row(s) first.");
        }      
    }
}